<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Vec Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_vec.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_vec-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Vec Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets.  
 <a href="class_vec.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_vec_8hpp_source.html">Vec.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a851e89b0653553745cb01ebf55268d56"><td class="memItemLeft" align="right" valign="top">double &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a851e89b0653553745cb01ebf55268d56">operator[]</a> (const unsigned int i)</td></tr>
<tr class="separator:a851e89b0653553745cb01ebf55268d56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e56ebfd280de14db0d12c906374d0a4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a2e56ebfd280de14db0d12c906374d0a4">Vec</a> (double x_=0, double y_=0, double z_=0)</td></tr>
<tr class="memdesc:a2e56ebfd280de14db0d12c906374d0a4"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_vec.html" title="A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. ">Vec</a> constructor.  <a href="#a2e56ebfd280de14db0d12c906374d0a4">More...</a><br /></td></tr>
<tr class="separator:a2e56ebfd280de14db0d12c906374d0a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a436959bd7cacc35bd0ec920ab6c4db10"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a436959bd7cacc35bd0ec920ab6c4db10">operator+</a> (const <a class="el" href="class_vec.html">Vec</a> &amp;b) const</td></tr>
<tr class="memdesc:a436959bd7cacc35bd0ec920ab6c4db10"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the result of adding a given vector to this vector.  <a href="#a436959bd7cacc35bd0ec920ab6c4db10">More...</a><br /></td></tr>
<tr class="separator:a436959bd7cacc35bd0ec920ab6c4db10"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd81c5160ec2a2a4ce0e13a95e344d9f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#afd81c5160ec2a2a4ce0e13a95e344d9f">operator-</a> (const <a class="el" href="class_vec.html">Vec</a> &amp;b) const</td></tr>
<tr class="memdesc:afd81c5160ec2a2a4ce0e13a95e344d9f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the result of subtracting a given vector to this vector.  <a href="#afd81c5160ec2a2a4ce0e13a95e344d9f">More...</a><br /></td></tr>
<tr class="separator:afd81c5160ec2a2a4ce0e13a95e344d9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a73ad126ecde40cd40d7f8d94a28f1d27"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a73ad126ecde40cd40d7f8d94a28f1d27">operator*</a> (double b) const</td></tr>
<tr class="memdesc:a73ad126ecde40cd40d7f8d94a28f1d27"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the result of performing an element-wise multiplication between this vector and a scalar.  <a href="#a73ad126ecde40cd40d7f8d94a28f1d27">More...</a><br /></td></tr>
<tr class="separator:a73ad126ecde40cd40d7f8d94a28f1d27"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f1779ed87ed0b6b1c8d6b30fb6973c7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a6f1779ed87ed0b6b1c8d6b30fb6973c7">operator/</a> (double b) const</td></tr>
<tr class="memdesc:a6f1779ed87ed0b6b1c8d6b30fb6973c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the result of performing an element-wise division between this vector and a given scalar.  <a href="#a6f1779ed87ed0b6b1c8d6b30fb6973c7">More...</a><br /></td></tr>
<tr class="separator:a6f1779ed87ed0b6b1c8d6b30fb6973c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40f86c7549206f61a8b92c0b0f734b7e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a40f86c7549206f61a8b92c0b0f734b7e">mult</a> (const <a class="el" href="class_vec.html">Vec</a> &amp;b) const</td></tr>
<tr class="memdesc:a40f86c7549206f61a8b92c0b0f734b7e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the result of performing an element-wise multiplication between this vector and another given vector.  <a href="#a40f86c7549206f61a8b92c0b0f734b7e">More...</a><br /></td></tr>
<tr class="separator:a40f86c7549206f61a8b92c0b0f734b7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5f9a71c878030b35a8399ea5def98924"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a5f9a71c878030b35a8399ea5def98924">div</a> (const <a class="el" href="class_vec.html">Vec</a> &amp;b) const</td></tr>
<tr class="memdesc:a5f9a71c878030b35a8399ea5def98924"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the result of performing an element-wise division between this vector and another given vector.  <a href="#a5f9a71c878030b35a8399ea5def98924">More...</a><br /></td></tr>
<tr class="separator:a5f9a71c878030b35a8399ea5def98924"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad565fbb5b8815047fc201f415e2779b2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#ad565fbb5b8815047fc201f415e2779b2">normalize</a> ()</td></tr>
<tr class="memdesc:ad565fbb5b8815047fc201f415e2779b2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a unit-length scaled version of this vector.  <a href="#ad565fbb5b8815047fc201f415e2779b2">More...</a><br /></td></tr>
<tr class="separator:ad565fbb5b8815047fc201f415e2779b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae690197cdfb7a9a0c07bed671263b2bf"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#ae690197cdfb7a9a0c07bed671263b2bf">norm</a> ()</td></tr>
<tr class="memdesc:ae690197cdfb7a9a0c07bed671263b2bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the norm of this vector.  <a href="#ae690197cdfb7a9a0c07bed671263b2bf">More...</a><br /></td></tr>
<tr class="separator:ae690197cdfb7a9a0c07bed671263b2bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff3033b4827d5ce26ad1652a0c92e4c0"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#aff3033b4827d5ce26ad1652a0c92e4c0">dot</a> (const <a class="el" href="class_vec.html">Vec</a> &amp;b) const</td></tr>
<tr class="memdesc:aff3033b4827d5ce26ad1652a0c92e4c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the dot-product between this vector and another given vector.  <a href="#aff3033b4827d5ce26ad1652a0c92e4c0">More...</a><br /></td></tr>
<tr class="separator:aff3033b4827d5ce26ad1652a0c92e4c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4671f57d4ff6d2af27703071c95a00bb"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a4671f57d4ff6d2af27703071c95a00bb">operator%</a> (<a class="el" href="class_vec.html">Vec</a> &amp;b)</td></tr>
<tr class="memdesc:a4671f57d4ff6d2af27703071c95a00bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the cross-product between this vector and another given vector.  <a href="#a4671f57d4ff6d2af27703071c95a00bb">More...</a><br /></td></tr>
<tr class="separator:a4671f57d4ff6d2af27703071c95a00bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6a161e229a763d5918933b60246d49fa"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a6a161e229a763d5918933b60246d49fa">print</a> ()</td></tr>
<tr class="memdesc:a6a161e229a763d5918933b60246d49fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends to the std::out information regarding this vector.  <a href="#a6a161e229a763d5918933b60246d49fa">More...</a><br /></td></tr>
<tr class="separator:a6a161e229a763d5918933b60246d49fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a6b06c403da715c182792139c41fb4e1a"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a6b06c403da715c182792139c41fb4e1a">x</a></td></tr>
<tr class="memdesc:a6b06c403da715c182792139c41fb4e1a"><td class="mdescLeft">&#160;</td><td class="mdescRight">First coordinate of this vector.  <a href="#a6b06c403da715c182792139c41fb4e1a">More...</a><br /></td></tr>
<tr class="separator:a6b06c403da715c182792139c41fb4e1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7e01ed5aadbe96e61e9192edf6cb740b"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a7e01ed5aadbe96e61e9192edf6cb740b">y</a></td></tr>
<tr class="memdesc:a7e01ed5aadbe96e61e9192edf6cb740b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Second coordinate of this vector.  <a href="#a7e01ed5aadbe96e61e9192edf6cb740b">More...</a><br /></td></tr>
<tr class="separator:a7e01ed5aadbe96e61e9192edf6cb740b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1517109e425feb5925733588631f862c"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_vec.html#a1517109e425feb5925733588631f862c">z</a></td></tr>
<tr class="memdesc:a1517109e425feb5925733588631f862c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Third coordinate of this vector.  <a href="#a1517109e425feb5925733588631f862c">More...</a><br /></td></tr>
<tr class="separator:a1517109e425feb5925733588631f862c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a2e56ebfd280de14db0d12c906374d0a4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2e56ebfd280de14db0d12c906374d0a4">&sect;&nbsp;</a></span>Vec()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Vec::Vec </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>x_</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>y_</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>z_</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A <a class="el" href="class_vec.html" title="A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. ">Vec</a> constructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a5f9a71c878030b35a8399ea5def98924"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5f9a71c878030b35a8399ea5def98924">&sect;&nbsp;</a></span>div()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Vec::div </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the result of performing an element-wise division between this vector and another given vector. </p>

</div>
</div>
<a id="aff3033b4827d5ce26ad1652a0c92e4c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff3033b4827d5ce26ad1652a0c92e4c0">&sect;&nbsp;</a></span>dot()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double Vec::dot </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the dot-product between this vector and another given vector. </p>

</div>
</div>
<a id="a40f86c7549206f61a8b92c0b0f734b7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a40f86c7549206f61a8b92c0b0f734b7e">&sect;&nbsp;</a></span>mult()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Vec::mult </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the result of performing an element-wise multiplication between this vector and another given vector. </p>

</div>
</div>
<a id="ae690197cdfb7a9a0c07bed671263b2bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae690197cdfb7a9a0c07bed671263b2bf">&sect;&nbsp;</a></span>norm()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double Vec::norm </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the norm of this vector. </p>

</div>
</div>
<a id="ad565fbb5b8815047fc201f415e2779b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad565fbb5b8815047fc201f415e2779b2">&sect;&nbsp;</a></span>normalize()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a>&amp; Vec::normalize </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a unit-length scaled version of this vector. </p>

</div>
</div>
<a id="a4671f57d4ff6d2af27703071c95a00bb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4671f57d4ff6d2af27703071c95a00bb">&sect;&nbsp;</a></span>operator%()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Vec::operator% </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the cross-product between this vector and another given vector. </p>

</div>
</div>
<a id="a73ad126ecde40cd40d7f8d94a28f1d27"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a73ad126ecde40cd40d7f8d94a28f1d27">&sect;&nbsp;</a></span>operator*()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Vec::operator* </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the result of performing an element-wise multiplication between this vector and a scalar. </p>

</div>
</div>
<a id="a436959bd7cacc35bd0ec920ab6c4db10"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a436959bd7cacc35bd0ec920ab6c4db10">&sect;&nbsp;</a></span>operator+()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Vec::operator+ </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the result of adding a given vector to this vector. </p>

</div>
</div>
<a id="afd81c5160ec2a2a4ce0e13a95e344d9f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afd81c5160ec2a2a4ce0e13a95e344d9f">&sect;&nbsp;</a></span>operator-()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Vec::operator- </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the result of subtracting a given vector to this vector. </p>

</div>
</div>
<a id="a6f1779ed87ed0b6b1c8d6b30fb6973c7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6f1779ed87ed0b6b1c8d6b30fb6973c7">&sect;&nbsp;</a></span>operator/()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Vec::operator/ </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the result of performing an element-wise division between this vector and a given scalar. </p>

</div>
</div>
<a id="a851e89b0653553745cb01ebf55268d56"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a851e89b0653553745cb01ebf55268d56">&sect;&nbsp;</a></span>operator[]()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double&amp; Vec::operator[] </td>
          <td>(</td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a6a161e229a763d5918933b60246d49fa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6a161e229a763d5918933b60246d49fa">&sect;&nbsp;</a></span>print()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Vec::print </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sends to the std::out information regarding this vector. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a6b06c403da715c182792139c41fb4e1a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6b06c403da715c182792139c41fb4e1a">&sect;&nbsp;</a></span>x</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Vec::x</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>First coordinate of this vector. </p>

</div>
</div>
<a id="a7e01ed5aadbe96e61e9192edf6cb740b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7e01ed5aadbe96e61e9192edf6cb740b">&sect;&nbsp;</a></span>y</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Vec::y</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Second coordinate of this vector. </p>

</div>
</div>
<a id="a1517109e425feb5925733588631f862c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1517109e425feb5925733588631f862c">&sect;&nbsp;</a></span>z</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Vec::z</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Third coordinate of this vector. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="_vec_8hpp_source.html">Vec.hpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_vec.html">Vec</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
